create sequence tci_seq start with 1;
create table C##PCORNET_4_1_WITH_NAMES.DEMOGRAPHIC (
  PATID varchar2(800),
  BIRTH_DATE date,
  BIRTH_TIME varchar2(5),
  SEX varchar2(2),
  SEXUAL_ORIENTATION varchar2(2),
  GENDER_IDENTITY varchar2(2),
  HISPANIC varchar2(2),
  RACE varchar2(2),
  BIOBANK_FLAG varchar2(1),
  PAT_PREF_LANGUAGE_SPOKEN varchar2(3),
  RAW_SEX varchar2(800),
  RAW_SEXUAL_ORIENTATION varchar2(800),
  RAW_GENDER_IDENTITY varchar2(800),
  RAW_HISPANIC varchar2(800),
  RAW_RACE varchar2(800),
  RAW_PAT_PREF_LANGUAGE_SPOKEN varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.ENCOUNTER (
  ENCOUNTERID varchar2(800),
  PATID varchar2(800),
  ADMIT_DATE date,
  ADMIT_TIME varchar2(5),
  DISCHARGE_DATE date,
  DISCHARGE_TIME varchar2(5),
  FACILITY_LOCATION varchar2(3),
  ENC_TYPE varchar2(2),
  FACILITYID varchar2(800),
  DISCHARGE_DISPOSITION varchar2(2),
  DISCHARGE_STATUS varchar2(2),
  DRG varchar2(3),
  DRG_TYPE varchar2(2),
  ADMITTING_SOURCE varchar2(2),
  PAYER_TYPE_PRIMARY varchar2(5) ,
  PAYER_TYPE_SECONDARY varchar2(5),
  FACILITY_TYPE varchar2(800),
  RAW_SITEID varchar2(800),
  RAW_ENC_TYPE varchar2(800),
  RAW_DISCHARGE_DISPOSITION varchar2(800),
  RAW_DISCHARGE_STATUS varchar2(800),
  RAW_DRG_TYPE varchar2(800),
  RAW_ADMITTING_SOURCE varchar2(800),
  RAW_FACILITY_TYPE varchar2(800),
  RAW_PAYER_TYPE_PRIMARY varchar2(800),
  RAW_PAYER_NAME_PRIMARY varchar2(800),
  RAW_PAYER_ID_PRIMARY varchar2(800),
  RAW_PAYER_TYPE_SECONDARY varchar2(800),
  RAW_PAYER_NAME_SECONDARY varchar2(800),
  RAW_PAYER_ID_SECONDARY varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.ENROLLMENT (
  PATID varchar2(800),
  ENR_START_DATE date,
  ENR_END_DATE date,
  CHART varchar2(1),
  ENR_BASIS varchar2(1)
);

create table C##PCORNET_4_1_WITH_NAMES.DIAGNOSIS (
  DIAGNOSISID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  ENC_TYPE varchar2(2),
  ADMIT_DATE date,
  DX varchar2(18),
  DX_TYPE varchar2(2),
  DX_SOURCE varchar2(2),
  DX_ORIGIN varchar2(2),
  PDX varchar2(2),
  DX_POA varchar2(2),
  RAW_DX varchar2(800),
  RAW_DX_TYPE varchar2(800),
  RAW_DX_SOURCE varchar2(800),
  RAW_PDX varchar2(800),
  RAW_DX_POA varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.PROCEDURES (
  PROCEDURESID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  ENC_TYPE varchar2(2),
  ADMIT_DATE date,
  PX_DATE date,
  PX varchar2(11),
  PX_TYPE varchar2(2),
  PX_SOURCE varchar2(2),
  PPX varchar2(2),
  RAW_PX varchar2(800),
  RAW_PX_TYPE varchar2(800),
  RAW_PPX varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.VITAL (
  VITALID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  MEASURE_DATE date,
  MEASURE_TIME varchar2(5),
  VITAL_SOURCE varchar2(2),
  HT float,
  WT float,
  DIASTOLIC float,
  SYSTOLIC float,
  ORIGINAL_BMI float,
  BP_POSITION varchar2(2),
  SMOKING varchar2(2),
  TOBACCO varchar2(2),
  TOBACCO_TYPE varchar2(2),
  RAW_DIASTOLIC varchar2(800),
  RAW_SYSTOLIC varchar2(800),
  RAW_BP_POSITION varchar2(800),
  RAW_SMOKING varchar2(800),
  RAW_TOBACCO varchar2(800),
  RAW_TOBACCO_TYPE varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.PRESCRIBING (
  PRESCRIBINGID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  RX_ORDER_DATE date,
  RX_ORDER_TIME varchar2(5),
  RX_START_DATE date,
  RX_END_DATE date,
  RX_DOSE_ORDERED float,
  RX_DOSE_ORDERED_UNIT varchar2(800),
  RX_QUANTITY float,
  RX_DOSE_FORM varchar2(800),
  RX_REFILLS float,
  RX_DAYS_SUPPLY float,
  RX_FREQUENCY varchar2(2),
  RX_PRN_FLAG varchar2(1),
  RX_ROUTE varchar2(800),
  RX_BASIS varchar2(2),
  RXNORM_CUI varchar2 (8),
  RX_SOURCE varchar2(2),
  RX_DISPENSE_AS_WRITTEN varchar2(2),
  RAW_RX_MED_NAME varchar2(800),
  RAW_RX_FREQUENCY varchar2(800),
  RAW_RXNORM_CUI varchar2(800),
  RAW_RX_QUANTITY varchar2(800),
  RAW_RX_NDC varchar2(800),
  RAW_RX_DOSE_ORDERED varchar2(800),
  RAW_RX_DOSE_ORDERED_UNIT varchar2(800),
  RAW_RX_ROUTE varchar2(800),
  RAW_RX_REFILLS varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.DISPENSING (
  DISPENSINGID varchar2(800),
  PATID varchar2(800),
  PRESCRIBINGID varchar2(800),
  DISPENSE_DATE date,
  NDC varchar2(11),
  DISPENSE_SUP float,
  DISPENSE_AMT float,
  DISPENSE_DOSE_DISP float,
  DISPENSE_DOSE_DISP_UNIT varchar2(800),
  DISPENSE_ROUTE varchar2(800),
  RAW_NDC varchar2(800),
  RAW_DISPENSE_DOSE_DISP varchar2(800),
  RAW_DISPENSE_DOSE_DISP_UNIT varchar2(800),
  RAW_DISPENSE_ROUTE varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.LAB_RESULT_CM (
  LAB_RESULT_CM_ID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  SPECIMEN_SOURCE varchar2(800),
  LAB_LOINC varchar2(10),
  PRIORITY varchar2(2),
  RESULT_LOC varchar2(2),
  LAB_PX varchar2(11),
  LAB_PX_TYPE varchar2(2),
  LAB_ORDER_DATE date,
  SPECIMEN_DATE date,
  SPECIMEN_TIME varchar2(5),
  RESULT_DATE date,
  RESULT_TIME varchar2(5),
  RESULT_QUAL varchar2(800),
  RESULT_SNOMED varchar2(800),
  RESULT_NUM float,
  RESULT_MODIFIER varchar2(2),
  RESULT_UNIT varchar2(800),
  NORM_RANGE_LOW varchar2(10),
  NORM_MODIFIER_LOW varchar2(2),
  NORM_RANGE_HIGH varchar2(10),
  NORM_MODIFIER_HIGH varchar2(2),
  ABN_IND varchar2(2),
  RAW_LAB_NAME varchar2(800),
  RAW_LAB_CODE varchar2(800),
  RAW_PANEL varchar2(800),
  RAW_RESULT varchar2(800),
  RAW_UNIT varchar2(800),
  RAW_ORDER_DEPT varchar2(800),
  RAW_FACILITY_CODE varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.CONDITION (
  CONDITIONID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  REPORT_DATE date,
  RESOLVE_DATE date,
  ONSET_DATE date,
  CONDITION_STATUS varchar2(2),
  CONDITION varchar2(18),
  CONDITION_TYPE varchar2(2),
  CONDITION_SOURCE varchar2(2),
  RAW_CONDITION_STATUS varchar2(800),
  RAW_CONDITION varchar2(800),
  RAW_CONDITION_TYPE varchar2(800),
  RAW_CONDITION_SOURCE varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.PRO_CM (
  PRO_CM_ID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  PRO_DATE date,
  PRO_TIME varchar2(5),
  PRO_TYPE varchar2(2),
  PRO_ITEM_NAME varchar2(800),
  PRO_ITEM_LOINC varchar2(10),
  PRO_RESPONSE_TEXT varchar2(800),
  PRO_RESPONSE_NUM float,
  PRO_METHOD varchar2(2),
  PRO_MODE varchar2(2),
  PRO_CAT varchar2(2),
  PRO_ITEM_VERSION varchar2(800),
  PRO_MEASURE_NAME varchar2(800),
  PRO_MEASURE_SEQ varchar2(800),
  PRO_MEASURE_SCORE float,
  PRO_MEASURE_THETA float,
  PRO_MEASURE_SCALED_TSCORE float,
  PRO_MEASURE_STANDARD_ERROR float,
  PRO_MEASURE_COUNT_SCORED float,
  PRO_MEASURE_LOINC varchar2(10),
  PRO_MEASURE_VERSION varchar2(800),
  PRO_ITEM_FULLNAME varchar2(800),
  PRO_ITEM_TEXT varchar2(800),
  PRO_MEASURE_FULLNAME varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.PCORNET_TRIAL (
  PATID varchar2(800),
  TRIALID varchar2(20),
  PARTICIPANTID varchar2(800),
  TRIAL_SITEID varchar2(800),
  TRIAL_ENROLL_DATE date,
  TRIAL_END_DATE date,
  TRIAL_WITHDRAW_DATE date,
  TRIAL_INVITE_CODE varchar2(20)
);

create table C##PCORNET_4_1_WITH_NAMES.DEATH (
  PATID varchar2(800),
  DEATH_DATE date,
  DEATH_DATE_IMPUTE varchar2(2),
  DEATH_SOURCE varchar2(2),
  DEATH_MATCH_CONFIDENCE varchar2(2)
);

create table C##PCORNET_4_1_WITH_NAMES.DEATH_CAUSE (
  PATID varchar2(800),
  DEATH_CAUSE varchar2(8),
  DEATH_CAUSE_CODE varchar2(2),
  DEATH_CAUSE_TYPE varchar2(2),
  DEATH_CAUSE_SOURCE varchar2(2),
  DEATH_CAUSE_CONFIDENCE varchar2(2)
);

create table C##PCORNET_4_1_WITH_NAMES.MED_ADMIN (
  MEDADMINID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  PRESCRIBINGID varchar2(800),
  MEDADMIN_START_DATE date,
  MEDADMIN_START_TIME varchar2(5),
  MEDADMIN_STOP_DATE date,
  MEDADMIN_STOP_TIME varchar2(5),
  MEDADMIN_TYPE varchar2(2),
  MEDADMIN_CODE varchar2(800),
  MEDADMIN_DOSE_ADMIN float,
  MEDADMIN_DOSE_ADMIN_UNIT varchar2(800),
  MEDADMIN_ROUTE varchar2(800),
  MEDADMIN_SOURCE varchar2(2),
  RAW_MEDADMIN_MED_NAME varchar2(800),
  RAW_MEDADMIN_CODE varchar2(800),
  RAW_MEDADMIN_DOSE_ADMIN varchar2(800),
  RAW_MEDADMIN_DOSE_ADMIN_UNIT varchar2(800),
  RAW_MEDADMIN_ROUTE varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.OBS_CLIN (
  OBSCLINID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  OBSCLIN_DATE date,
  OBSCLIN_TIME varchar2(5) ,
  OBSCLIN_TYPE varchar2(2),
  OBSCLIN_CODE varchar2(800),
  OBSCLIN_RESULT_QUAL varchar2(800),
  OBSCLIN_RESULT_TEXT varchar2(800),
  OBSCLIN_RESULT_SNOMED varchar2(800),
  OBSCLIN_RESULT_NUM float,
  OBSCLIN_RESULT_MODIFIER varchar2(2),
  OBSCLIN_RESULT_UNIT varchar2(800),
  RAW_OBSCLIN_NAME varchar2(800),
  RAW_OBSCLIN_CODE varchar2(800),
  RAW_OBSCLIN_TYPE varchar2(800),
  RAW_OBSCLIN_RESULT varchar2(800),
  RAW_OBSCLIN_MODIFIER varchar2(800),
  RAW_OBSCLIN_UNIT varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.OBS_GEN (
  OBSGENID varchar2(800),
  PATID varchar2(800),
  ENCOUNTERID varchar2(800),
  OBSGEN_DATE date,
  OBSGEN_TIME varchar2(5) ,
  OBSGEN_TYPE varchar2(30),
  OBSGEN_CODE varchar2(800),
  OBSGEN_RESULT_QUAL varchar2(800),
  OBSGEN_RESULT_TEXT varchar2(800),
  OBSGEN_RESULT_NUM float,
  OBSGEN_RESULT_MODIFIER varchar2(2),
  OBSGEN_RESULT_UNIT varchar2(800),
  OBSGEN_TABLE_MODIFIED varchar2(3),
  OBSGEN_ID_MODIFIED varchar2(800),
  RAW_OBSGEN_NAME varchar2(800),
  RAW_OBSGEN_CODE varchar2(800),
  RAW_OBSGEN_TYPE varchar2(800),
  RAW_OBSGEN_RESULT varchar2(800),
  RAW_OBSGEN_UNIT varchar2(800)
);

create table C##PCORNET_4_1_WITH_NAMES.HARVEST (
  NETWORKID varchar2(10),
  NETWORK_NAME varchar2(20),
  DATAMARTID varchar2(10),
  DATAMART_NAME varchar2(20),
  DATAMART_PLATFORM varchar2(2),
  CDM_VERSION float,
  DATAMART_CLAIMS varchar2(2),
  DATAMART_EHR varchar2(2),
  BIRTH_DATE_MGMT varchar2(2),
  ENR_START_DATE_MGMT varchar2(2),
  ENR_END_DATE_MGMT varchar2(2),
  ADMIT_DATE_MGMT varchar2(2),
  DISCHARGE_DATE_MGMT varchar2(2),
  PX_DATE_MGMT varchar2(2),
  RX_ORDER_DATE_MGMT varchar2(2),
  RX_START_DATE_MGMT varchar2(2),
  RX_END_DATE_MGMT varchar2(2),
  DISPENSE_DATE_MGMT varchar2(2),
  LAB_ORDER_DATE_MGMT varchar2(2),
  SPECIMEN_DATE_MGMT varchar2(2),
  RESULT_DATE_MGMT varchar2(2),
  MEASURE_DATE_MGMT varchar2(2),
  ONSET_DATE_MGMT varchar2(2),
  REPORT_DATE_MGMT varchar2(2),
  RESOLVE_DATE_MGMT varchar2(2),
  PRO_DATE_MGMT varchar2(2),
  DEATH_DATE_MGMT varchar2(2),
  MEDADMIN_START_DATE_MGMT varchar2(2),
  MEDADMIN_STOP_DATE_MGMT varchar2(2),
  OBSCLIN_DATE_MGMT varchar2(2),
  OBSGEN_DATE_MGMT varchar2(2),
  REFRESH_DEMOGRAPHIC_DATE date,
  REFRESH_ENROLLMENT_DATE date,
  REFRESH_ENCOUNTER_DATE date,
  REFRESH_DIAGNOSIS_DATE date,
  REFRESH_PROCEDURES_DATE date,
  REFRESH_VITAL_DATE date,
  REFRESH_DISPENSING_DATE date,
  REFRESH_LAB_RESULT_CM_DATE date,
  REFRESH_CONDITION_DATE date,
  REFRESH_PRO_CM_DATE date,
  REFRESH_PRESCRIBING_DATE date,
  REFRESH_PCORNET_TRIAL_DATE date,
  REFRESH_DEATH_DATE date,
  REFRESH_DEATH_CAUSE_DATE date,
  REFRESH_MED_ADMIN_DATE date,
  REFRESH_OBS_CLIN_DATE date,
  REFRESH_OBS_GEN_DATE date
);


-- Constraints
alter table ENCOUNTER modify PATID not null;
alter table ENCOUNTER modify ADMIT_DATE not null;
alter table ENCOUNTER modify ENC_TYPE not null;
alter table ENROLLMENT modify PATID not null;
alter table ENROLLMENT modify ENR_START_DATE not null;
alter table ENROLLMENT modify ENR_BASIS not null;
alter table DIAGNOSIS modify PATID not null;
alter table DIAGNOSIS modify DX not null;
alter table DIAGNOSIS modify DX_TYPE not null;
alter table DIAGNOSIS modify DX_SOURCE not null;
alter table PROCEDURES modify PATID not null;
alter table PROCEDURES modify PX not null;
alter table PROCEDURES modify PX_TYPE not null;
alter table VITAL modify PATID not null;
alter table VITAL modify MEASURE_DATE not null;
alter table VITAL modify VITAL_SOURCE not null;
alter table PRESCRIBING modify PATID not null;
alter table DISPENSING modify PATID not null;
alter table DISPENSING modify DISPENSE_DATE not null;
alter table DISPENSING modify NDC not null;
alter table LAB_RESULT_CM modify PATID not null;
alter table LAB_RESULT_CM modify RESULT_DATE not null;
alter table CONDITION modify PATID not null;
alter table CONDITION modify CONDITION not null;
alter table CONDITION modify CONDITION_TYPE not null;
alter table CONDITION modify CONDITION_SOURCE not null;
alter table PRO_CM modify PATID not null;
alter table PRO_CM modify PRO_DATE not null;
alter table PCORNET_TRIAL modify PATID not null;
alter table PCORNET_TRIAL modify TRIALID not null;
alter table PCORNET_TRIAL modify PARTICIPANTID not null;
alter table DEATH modify PATID not null;
alter table DEATH modify DEATH_SOURCE not null;
alter table DEATH_CAUSE modify PATID not null;
alter table DEATH_CAUSE modify DEATH_CAUSE not null;
alter table DEATH_CAUSE modify DEATH_CAUSE_CODE not null;
alter table DEATH_CAUSE modify DEATH_CAUSE_TYPE not null;
alter table DEATH_CAUSE modify DEATH_CAUSE_SOURCE not null;
alter table MED_ADMIN modify PATID not null;
alter table MED_ADMIN modify MEDADMIN_START_DATE not null;
alter table OBS_CLIN modify PATID not null;
alter table OBS_CLIN modify OBSCLIN_DATE not null;
alter table OBS_GEN modify PATID not null;
alter table OBS_GEN modify OBSGEN_DATE not null;
alter table HARVEST modify NETWORKID not null;
alter table HARVEST modify DATAMARTID not null;
-- Primary Keys
alter table DEMOGRAPHIC add constraint pkDEMOGRAPHIC primary key (PATID);
alter table ENCOUNTER add constraint pkENCOUNTER primary key (ENCOUNTERID);
alter table DIAGNOSIS add constraint pkDIAGNOSIS primary key (DIAGNOSISID);
alter table PROCEDURES add constraint pkPROCEDURES primary key (PROCEDURESID);
alter table VITAL add constraint pkVITAL primary key (VITALID);
alter table PRESCRIBING add constraint pkPRESCRIBING primary key (PRESCRIBINGID);
alter table DISPENSING add constraint pkDISPENSING primary key (DISPENSINGID);
alter table LAB_RESULT_CM add constraint pkLAB_RESULT_CM primary key (LAB_RESULT_CM_ID);
alter table CONDITION add constraint pkCONDITION primary key (CONDITIONID);
alter table PRO_CM add constraint pkPRO_CM primary key (PRO_CM_ID);
alter table MED_ADMIN add constraint pkMED_ADMIN primary key (MEDADMINID);
alter table OBS_CLIN add constraint pkOBS_CLIN primary key (OBSCLINID);
alter table OBS_GEN add constraint pkOBS_GEN primary key (OBSGENID);

-- Foreign Keys
alter table ENCOUNTER add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table ENROLLMENT add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table DIAGNOSIS add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table PROCEDURES add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table VITAL add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table PRESCRIBING add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table DISPENSING add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table LAB_RESULT_CM add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table CONDITION add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table PRO_CM add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table PCORNET_TRIAL add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table DEATH add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table DEATH_CAUSE add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table MED_ADMIN add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table OBS_CLIN add foreign key (PATID) references DEMOGRAPHIC (PATID);
alter table OBS_GEN add foreign key (PATID) references DEMOGRAPHIC (PATID);
